@istest
private class MatSerUpdateGroupTest {
    static testmethod void defaultUpdate(){
        User u = [ Select Id, Name from User where Id =: UserInfo.getUserId() limit 1 ];
        
        PREP_Discipline__c disp = new PREP_Discipline__c( Name = 'Engineering & Construction', Active__c = true, SCM_Manager__c = u.Id );
        insert disp;
        
        PREP_Category__c cat = new PREP_Category__c( Name = 'Category', Active__c = true, Discipline__c = disp.Id );
        insert cat;
        
        PREP_Sub_Category__c sub = new PREP_Sub_Category__c( Name = 'SubCat', Category__c = cat.Id, Category_Manager__c = u.Id,
                                                                Category_Specialist__c = u.Id, Active__c = true );
        insert sub;
        
        PREP_Initiative__c ini = new PREP_Initiative__c( Initiative_Name__c = 'Test ini', Discipline__c = disp.Id, Category__c = cat.Id,
                                Sub_Category__c = sub.Id, Status__c = 'Active', Sourcing_Program__c='delivary Plan', Type__c = 'Category',
                                Risk_Level__c = 'High', HSSM_Package__c = 'Full', Workbook__c = 'Yes', SRPM_Package__c = 'As Needed',
                                Aboriginal__c = 'No', Global_Sourcing__c = 'Yes', OEM__c = 'Yes', Ariba__c='Yes', Ariba_Exception_Reason__c='Singlr Source',
                                Rate_Validation__c = 'Yes', Estimated_Number_of_Master_Data_Required__c=100, Reverse_Auction__c = 'No',
                                Rebate__c = 'Multiple Area Award', Rebate_Frequency__c = 'Annually',PDE_Phase__c='1',Phase_4_Start_Date__c=Date.newInstance(2017, 7, 7),Phase_4_Completion_Date__c=Date.newInstance(2018, 7, 7),
                                Volume_Discount_Frequency__c='Annually', Payment_Terms__c='Net 30', SCM_Manager__c = u.Id, SCM_Team__c='E&C - Equipment',
                                Category_Manager__c = u.Id, Category_Specialist__c = u.Id, RecordTypeId ='01216000001QPTv' );
        insert ini;
        
        PREP_Baseline__c baseline = new PREP_Baseline__c();
        baseline.Baseline_Spend_Dollar_Target__c = 10000;
        baseline.Local_Baseline_Spend_Percent__c = 0.10;
        baseline.Local_Baseline_Savings_Percent__c = 0.10;
        baseline.Global_Baseline_Savings_Percent__c = 0.10;
        baseline.XCAC2_CAC_Award_Approval__c = Date.newInstance(2015, 5, 10);
        baseline.RecordTypeId = '01216000001QPTt';
        baseline.Initiative_Id__c = ini.Id;
        insert baseline;
        
        PREP_Material_Service_Group__c MS = new PREP_Material_Service_Group__c();
        MS.Name = 'MS Name';
        MS.Material_Service_Group_Name__c = 'MS';
        MS.Category_Link__c= cat.Id;
        MS.Sub_Category__c = sub.Id;
        MS.Category_Manager__c = u.Id;
        MS.SAP_Short_Text_Name__c = 'MS';
        MS.Active__c = true;
        MS.Type__c = 'Material';
        MS.Category_Specialist__c = u.Id;
        MS.Includes__c = 'MS';
        MS.Does_Not_Include__c = 'MS';
        //MS.PREP_ForecastDates=Date.newInstance(2015, 5, 10);
        insert MS;
        
        PREP_Mat_Serv_Group_Baseline_Allocation__c MSA = new PREP_Mat_Serv_Group_Baseline_Allocation__c();
        MSA.Baseline_Id__c = baseline.Id;
        MSA.Material_Service_Group__c = MS.Id;
        //MSA.Phase_4_Completion_Date__c=Date.newInstance(2015, 5, 10);
        MSA.RecordTypeId = '01216000001QPTw';
        MSA.Sub_Category__c = sub.Id;
        insert MSA;
        
        PREP_Acquisition_Cycle__c MatAcqCycle = new PREP_Acquisition_Cycle__c();
       // MatAcqCycle.Initiative__c= ini.Id;
        MatAcqCycle.Mat_Serv_Group_Baseline_Allocation__c = MSA.Id;
        MatAcqCycle.RFQ_Prep__c = 3;
        MatAcqCycle.Bid_Period__c =  28;
        MatAcqCycle.Bid_Evaluation_1__c = 21;
        MatAcqCycle.Bid_Evaluation_2__c = 21;
        MatAcqCycle.Bid_Evaluation_3__c = 2;
        MatAcqCycle.Bid_Evaluation_4__c = 7;
        MatAcqCycle.Husky_Approval__c = 7;
        MatAcqCycle.MRP_Prep__c = 7;
        MatAcqCycle.PO_Prep_Issue__c = 9; 
        MatAcqCycle.Shipping_Duration__c = 7;
        MatAcqCycle.Type__c = 'Standard 12';
        MatAcqCycle.RecordTypeId = '01216000001QPTr';
        insert MatAcqCycle;
        
        PREP_Mat_Serv_Group_Planned_Schedule__c msps = new PREP_Mat_Serv_Group_Planned_Schedule__c();
        msps.Acquisition_Cycle_Type__c='Standard 12';
        msps.Acquisition_Cycle__c=MatAcqCycle.Id;
        msps.Mat_Serv_Group_Baseline_Allocation_Id__c=MSA.Id;
        msps.R_A_S_Date__c=Date.newInstance(2018, 4, 9);
        msps.Phase_4_Completion_Date__c= Date.newInstance(2018, 5, 10);
        msps.Critical_Vendor_Data_Receipt_1_Weeks__c=2;
        msps.Critical_Vendor_Data_Receipt_2_Weeks__c=2;
        msps.MFG_Lead_Time_Weeks__c=3;
        msps.RecordTypeId='01216000001QPTy';
        insert msps;
        
        Id matId = Schema.SObjectType.PREP_Mat_Serv_Group_Update__c.getRecordTypeInfosByName().get('Mat Group Update').getRecordTypeId();
        Id servId = Schema.SObjectType.PREP_Mat_Serv_Group_Update__c.getRecordTypeInfosByName().get('Serv Group Update').getRecordTypeId();      
        
        PREP_Mat_Serv_Group_Update__c msgu =   new PREP_Mat_Serv_Group_Update__c();
        msgu.Mat_Serv_Group_Planned_Schedule_Id__c =msps.Id;
        msgu.R_A_S_Date__c =Date.newInstance(2017, 7, 7)  ;
        msgu.Planned_Bid_Request_Issued_RFQ__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_MRQ_Received__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Bids_Received__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Commercial_Evaluations_Received__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Technical_Evaluations_Received__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Bid_Tab_Finalized__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Decision_Sum_Issued_Approval__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Decision_Summary_Approved__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_MRP_Received__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_P_O_Issued__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Vendor_Init_Drawing_Submittal__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Drawings_Approved__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Ship_Date__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_ETA__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_Business_Requirements__c =2;
        msgu.Planned_1_Segmentation_Team_Selection__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_1_Segmentation_Team_Selection__c= Date.newInstance(2017, 7, 7);
        msgu.Planned_2_Business_Requirements__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_3_Supplier_Market_Analysis__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_4_Sourcing_Options__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Strategy_Approval__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Strategy_Approval__c =Date.newInstance(2017, 7, 7);
        msgu.Forecast_Supplier_Market_Analysis__c=1;
        msgu.Forecast_Sourcing_Options__c=3;
        msgu.Forecast_Strategy_Approval_Cycle__c=3;
        msgu.Forecast_Strategy_Approval__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_MRQ_To_Be_Received__c=3;
        msgu.Forecast_Bid_Period__c=3;
        msgu.Forecast_RFQ_Prep__c=2;
        msgu.Actual_MRQ_Received__c =Date.newInstance(2017, 7, 7);
        msgu.Actual_Bid_Request_Issued_RFQ__c =Date.newInstance(2017, 7, 7);
        msgu.Forecast_Bid_Evaluation_1__c=1;
        msgu.Forecast_Bid_Evaluation_2__c=3;
        msgu.Actual_Bids_Received__c = Date.newInstance(2017, 7, 7);
        msgu.Actual_Comm_Eval_Received__c =Date.newInstance(2017, 7, 7);
        msgu.Actual_Tech_Eval_Received__c =Date.newInstance(2017, 7, 7);
        msgu.Forecast_Comm_Eval_Received_Mat__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_Bid_Evaluation_3__c=3;
        msgu.Actual_Comm_Eval_Received__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_Bid_Evaluation_4__c=2;
        msgu.Forecast_Husky_Approval__c=4;
        msgu.Forecast_MRP_Prep__c=2;
        msgu.Forecast_PO_Prep_Issued__c=3;
        msgu.Forecast_Critical_Vendor_Data_Receipt1_W__c=4;
        msgu.Forecast_Critical_Vendor_Data_Receipt2_W__c=1;
        msgu.Forecast_MFG_Lead_Time_Weeks__c=1;
        msgu.Forecast_Shipping_Duration__c=1;
        msgu.Actual_1_Segmentation_Team_Selection__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_2_Business_Requirements__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_Business_Requirements__c = 1;
        msgu.Actual_2_Business_Requirements__c = Date.newInstance(2017, 7, 7);
        msgu.Actual_3_Supplier_Market_Analysis__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_4_Sourcing_Options__c = Date.newInstance(2017, 7, 7);
        msgu.Actual_Strategy_Approval__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_Bids_Received_Mat__c = Date.newInstance(2017, 7, 7);
        msgu.Actual_4_Sourcing_Options__c = Date.newInstance(2017, 7, 7);
        msgu.Actual_Bid_Tab_Finalized__c = Date.newInstance(2017, 7, 7);
        msgu.Actual_Decision_Sum_Issued_Approval__c = Date.newInstance(2017, 7, 7);
        //msgu.Actual_Decision_Summary_Approved__c = Date.newInstance(2017, 7, 7);
        msgu.Actual_MRP_Received__c = Date.newInstance(2017, 7, 7);
        msgu.Actual_P_O_Issued__c = Date.newInstance(2017, 7, 7);
        msgu.Actual_Vendor_Init_Drawing_Submittal__c = Date.newInstance(2017, 7, 7);
        msgu.Actual_Drawings_Approved__c = Date.newInstance(2017, 7, 7);
        msgu.Actual_Ship_Date__c = Date.newInstance(2017, 7, 7);
        msgu.Actual_ETA__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Contract_Execution__c = Date.newInstance(2017, 7, 7);
        msgu.RecordTypeId = matId;
        insert msgu;
        
        test.startTest();
            update msgu;
        test.stopTest();
    }
    
    static testmethod void defaultUpdate1(){
        User u = [ Select Id, Name from User where Id =: UserInfo.getUserId() limit 1 ];
        
        PREP_Discipline__c disp = new PREP_Discipline__c( Name = 'Engineering & Construction', Active__c = true, SCM_Manager__c = u.Id );
        insert disp;
        
        PREP_Category__c cat = new PREP_Category__c( Name = 'Category', Active__c = true, Discipline__c = disp.Id );
        insert cat;
        
        PREP_Sub_Category__c sub = new PREP_Sub_Category__c( Name = 'SubCat', Category__c = cat.Id, Category_Manager__c = u.Id,
                                                                Category_Specialist__c = u.Id, Active__c = true );
        insert sub;
        
        PREP_Initiative__c ini = new PREP_Initiative__c( Initiative_Name__c = 'Test ini', Discipline__c = disp.Id, Category__c = cat.Id,
                                Sub_Category__c = sub.Id, Status__c = 'Active', Sourcing_Program__c='delivary Plan', Type__c = 'Category',
                                Risk_Level__c = 'High', HSSM_Package__c = 'Full', Workbook__c = 'Yes', SRPM_Package__c = 'As Needed',
                                Aboriginal__c = 'No', Global_Sourcing__c = 'Yes', OEM__c = 'Yes', Ariba__c='Yes', Ariba_Exception_Reason__c='Singlr Source',
                                Rate_Validation__c = 'Yes', Estimated_Number_of_Master_Data_Required__c=100, Reverse_Auction__c = 'No',
                                Rebate__c = 'Multiple Area Award', Rebate_Frequency__c = 'Annually',PDE_Phase__c='1',Phase_4_Start_Date__c=Date.newInstance(2017, 7, 7),Phase_4_Completion_Date__c=Date.newInstance(2018, 7, 7),
                                Volume_Discount_Frequency__c='Annually', Payment_Terms__c='Net 30', SCM_Manager__c = u.Id, SCM_Team__c='E&C - Equipment',
                                Category_Manager__c = u.Id, Category_Specialist__c = u.Id, RecordTypeId ='01216000001QPTv' );
        insert ini;
        
        PREP_Baseline__c baseline = new PREP_Baseline__c();
        baseline.Baseline_Spend_Dollar_Target__c = 10000;
        baseline.Local_Baseline_Spend_Percent__c = 0.10;
        baseline.Local_Baseline_Savings_Percent__c = 0.10;
        baseline.Global_Baseline_Savings_Percent__c = 0.10;
        baseline.XCAC2_CAC_Award_Approval__c = Date.newInstance(2015, 5, 10);
        baseline.RecordTypeId = '01216000001QPTt';
        baseline.Initiative_Id__c = ini.Id;
        insert baseline;
        
        PREP_Material_Service_Group__c MS = new PREP_Material_Service_Group__c();
        MS.Name = 'MS Name';
        MS.Material_Service_Group_Name__c = 'MS';
        MS.Category_Link__c= cat.Id;
        MS.Sub_Category__c = sub.Id;
        MS.Category_Manager__c = u.Id;
        MS.SAP_Short_Text_Name__c = 'MS';
        MS.Active__c = true;
        MS.Type__c = 'Material';
        MS.Category_Specialist__c = u.Id;
        MS.Includes__c = 'MS';
        MS.Does_Not_Include__c = 'MS';
        //MS.PREP_ForecastDates=Date.newInstance(2015, 5, 10);
        insert MS;
        
        PREP_Mat_Serv_Group_Baseline_Allocation__c MSA = new PREP_Mat_Serv_Group_Baseline_Allocation__c();
        MSA.Baseline_Id__c = baseline.Id;
        MSA.Material_Service_Group__c = MS.Id;
        //MSA.Phase_4_Completion_Date__c=Date.newInstance(2015, 5, 10);
        MSA.RecordTypeId = '01216000001QPTw';
        MSA.Sub_Category__c = sub.Id;
        insert MSA;
        
        PREP_Acquisition_Cycle__c MatAcqCycle = new PREP_Acquisition_Cycle__c();
       // MatAcqCycle.Initiative__c= ini.Id;
        MatAcqCycle.Mat_Serv_Group_Baseline_Allocation__c = MSA.Id;
        MatAcqCycle.RFQ_Prep__c = 3;
        MatAcqCycle.Bid_Period__c =  28;
        MatAcqCycle.Bid_Evaluation_1__c = 21;
        MatAcqCycle.Bid_Evaluation_2__c = 21;
        MatAcqCycle.Bid_Evaluation_3__c = 2;
        MatAcqCycle.Bid_Evaluation_4__c = 7;
        MatAcqCycle.Husky_Approval__c = 7;
        MatAcqCycle.MRP_Prep__c = 7;
        MatAcqCycle.PO_Prep_Issue__c = 9; 
        MatAcqCycle.Shipping_Duration__c = 7;
        MatAcqCycle.Type__c = 'Standard 12';
        MatAcqCycle.RecordTypeId = '01216000001QPTr';
        insert MatAcqCycle;
        
        PREP_Mat_Serv_Group_Planned_Schedule__c msps = new PREP_Mat_Serv_Group_Planned_Schedule__c();
        msps.Acquisition_Cycle_Type__c='Standard 12';
        msps.Acquisition_Cycle__c=MatAcqCycle.Id;
        msps.Mat_Serv_Group_Baseline_Allocation_Id__c=MSA.Id;
        msps.R_A_S_Date__c=Date.newInstance(2018, 4, 9);
        msps.Phase_4_Completion_Date__c= Date.newInstance(2018, 5, 10);
        msps.Critical_Vendor_Data_Receipt_1_Weeks__c=2;
        msps.Critical_Vendor_Data_Receipt_2_Weeks__c=2;
        msps.MFG_Lead_Time_Weeks__c=3;
        msps.RecordTypeId='01216000001QPTy';
        insert msps;
        
        Id matId = Schema.SObjectType.PREP_Mat_Serv_Group_Update__c.getRecordTypeInfosByName().get('Mat Group Update').getRecordTypeId();
        Id servId = Schema.SObjectType.PREP_Mat_Serv_Group_Update__c.getRecordTypeInfosByName().get('Serv Group Update').getRecordTypeId();      
        
        PREP_Mat_Serv_Group_Update__c msgu =   new PREP_Mat_Serv_Group_Update__c();
        msgu.Mat_Serv_Group_Planned_Schedule_Id__c =msps.Id;
        msgu.R_A_S_Date__c =Date.newInstance(2018, 7, 7)  ;
        msgu.Planned_Bid_Request_Issued_RFQ__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_MRQ_Received__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Bids_Received__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Commercial_Evaluations_Received__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Technical_Evaluations_Received__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Bid_Tab_Finalized__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Decision_Sum_Issued_Approval__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Decision_Summary_Approved__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_MRP_Received__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_P_O_Issued__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Vendor_Init_Drawing_Submittal__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Drawings_Approved__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Ship_Date__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_ETA__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_Business_Requirements__c =2;
        msgu.Planned_1_Segmentation_Team_Selection__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_1_Segmentation_Team_Selection__c= Date.newInstance(2018, 7, 7);
        msgu.Planned_2_Business_Requirements__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_3_Supplier_Market_Analysis__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_4_Sourcing_Options__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Strategy_Approval__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Strategy_Approval__c =Date.newInstance(2018, 7, 7);
        msgu.Forecast_Supplier_Market_Analysis__c=1;
        msgu.Forecast_Sourcing_Options__c=3;
        msgu.Forecast_Strategy_Approval_Cycle__c=3;
        msgu.Forecast_Strategy_Approval__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_MRQ_To_Be_Received__c=3;
        msgu.Forecast_Bid_Period__c=3;
        msgu.Forecast_RFQ_Prep__c=2;
        msgu.Actual_MRQ_Received__c =Date.newInstance(2018, 7, 7);
        msgu.Actual_Bid_Request_Issued_RFQ__c =Date.newInstance(2018, 7, 7);
        msgu.Forecast_Bid_Evaluation_1__c=1;
        msgu.Forecast_Bid_Evaluation_2__c=3;
        msgu.Actual_Bids_Received__c = Date.newInstance(2018, 7, 7);
        msgu.Actual_Comm_Eval_Received__c =Date.newInstance(2018, 7, 7);
        msgu.Actual_Tech_Eval_Received__c =Date.newInstance(2018, 7, 7);
        msgu.Forecast_Comm_Eval_Received_Mat__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_Bid_Evaluation_3__c=3;
        msgu.Actual_Comm_Eval_Received__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_Bid_Evaluation_4__c=2;
        msgu.Forecast_Husky_Approval__c=4;
        msgu.Forecast_MRP_Prep__c=2;
        msgu.Forecast_PO_Prep_Issued__c=3;
        msgu.Forecast_Critical_Vendor_Data_Receipt1_W__c=4;
        msgu.Forecast_Critical_Vendor_Data_Receipt2_W__c=1;
        msgu.Forecast_MFG_Lead_Time_Weeks__c=1;
        msgu.Forecast_Shipping_Duration__c=1;
        msgu.Actual_1_Segmentation_Team_Selection__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_2_Business_Requirements__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_Business_Requirements__c = 1;
        msgu.Actual_2_Business_Requirements__c = Date.newInstance(2018, 7, 7);
        msgu.Actual_3_Supplier_Market_Analysis__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_4_Sourcing_Options__c = Date.newInstance(2018, 7, 7);
        msgu.Actual_Strategy_Approval__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_Bids_Received_Mat__c = Date.newInstance(2018, 7, 7);
        msgu.RecordTypeId = matId;
        insert msgu;
        
        test.startTest();
            update msgu;
        test.stopTest();
    }
    
    static testmethod void defaultUpdate2(){
        User u = [ Select Id, Name from User where Id =: UserInfo.getUserId() limit 1 ];
        
        PREP_Discipline__c disp = new PREP_Discipline__c( Name = 'Engineering & Construction', Active__c = true, SCM_Manager__c = u.Id );
        insert disp;
        
        PREP_Category__c cat = new PREP_Category__c( Name = 'Category', Active__c = true, Discipline__c = disp.Id );
        insert cat;
        
        PREP_Sub_Category__c sub = new PREP_Sub_Category__c( Name = 'SubCat', Category__c = cat.Id, Category_Manager__c = u.Id,
                                                                Category_Specialist__c = u.Id, Active__c = true );
        insert sub;
        
        PREP_Initiative__c ini = new PREP_Initiative__c( Initiative_Name__c = 'Test ini', Discipline__c = disp.Id, Category__c = cat.Id,
                                Sub_Category__c = sub.Id, Status__c = 'Active', Sourcing_Program__c='delivary Plan', Type__c = 'Category',
                                Risk_Level__c = 'High', HSSM_Package__c = 'Full', Workbook__c = 'Yes', SRPM_Package__c = 'As Needed',
                                Aboriginal__c = 'No', Global_Sourcing__c = 'Yes', OEM__c = 'Yes', Ariba__c='Yes', Ariba_Exception_Reason__c='Singlr Source',
                                Rate_Validation__c = 'Yes', Estimated_Number_of_Master_Data_Required__c=100, Reverse_Auction__c = 'No',
                                Rebate__c = 'Multiple Area Award', Rebate_Frequency__c = 'Annually',PDE_Phase__c='1',Phase_4_Start_Date__c=Date.newInstance(2017, 7, 7),Phase_4_Completion_Date__c=Date.newInstance(2018, 7, 7),
                                Volume_Discount_Frequency__c='Annually', Payment_Terms__c='Net 30', SCM_Manager__c = u.Id, SCM_Team__c='E&C - Equipment',
                                Category_Manager__c = u.Id, Category_Specialist__c = u.Id, RecordTypeId ='01216000001QPTv' );
        insert ini;
        
        PREP_Baseline__c baseline = new PREP_Baseline__c();
        baseline.Baseline_Spend_Dollar_Target__c = 10000;
        baseline.Local_Baseline_Spend_Percent__c = 0.10;
        baseline.Local_Baseline_Savings_Percent__c = 0.10;
        baseline.Global_Baseline_Savings_Percent__c = 0.10;
        baseline.XCAC2_CAC_Award_Approval__c = Date.newInstance(2015, 5, 10);
        baseline.RecordTypeId = '01216000001QPTt';
        baseline.Initiative_Id__c = ini.Id;
        insert baseline;
        
        PREP_Material_Service_Group__c MS = new PREP_Material_Service_Group__c();
        MS.Name = 'MS Name';
        MS.Material_Service_Group_Name__c = 'MS';
        MS.Category_Link__c= cat.Id;
        MS.Sub_Category__c = sub.Id;
        MS.Category_Manager__c = u.Id;
        MS.SAP_Short_Text_Name__c = 'MS';
        MS.Active__c = true;
        MS.Type__c = 'Material';
        MS.Category_Specialist__c = u.Id;
        MS.Includes__c = 'MS';
        MS.Does_Not_Include__c = 'MS';
        //MS.PREP_ForecastDates=Date.newInstance(2015, 5, 10);
        insert MS;
        
        PREP_Mat_Serv_Group_Baseline_Allocation__c MSA = new PREP_Mat_Serv_Group_Baseline_Allocation__c();
        MSA.Baseline_Id__c = baseline.Id;
        MSA.Material_Service_Group__c = MS.Id;
        //MSA.Phase_4_Completion_Date__c=Date.newInstance(2015, 5, 10);
        MSA.RecordTypeId = '01216000001QPTw';
        MSA.Sub_Category__c = sub.Id;
        insert MSA;
        
        PREP_Acquisition_Cycle__c MatAcqCycle = new PREP_Acquisition_Cycle__c();
       // MatAcqCycle.Initiative__c= ini.Id;
        MatAcqCycle.Mat_Serv_Group_Baseline_Allocation__c = MSA.Id;
        MatAcqCycle.RFQ_Prep__c = 3;
        MatAcqCycle.Bid_Period__c =  28;
        MatAcqCycle.Bid_Evaluation_1__c = 21;
        MatAcqCycle.Bid_Evaluation_2__c = 21;
        MatAcqCycle.Bid_Evaluation_3__c = 2;
        MatAcqCycle.Bid_Evaluation_4__c = 7;
        MatAcqCycle.Husky_Approval__c = 7;
        MatAcqCycle.MRP_Prep__c = 7;
        MatAcqCycle.PO_Prep_Issue__c = 9; 
        MatAcqCycle.Shipping_Duration__c = 7;
        MatAcqCycle.Type__c = 'Standard 12';
        MatAcqCycle.RecordTypeId = '01216000001QPTr';
        insert MatAcqCycle;
        
        PREP_Mat_Serv_Group_Planned_Schedule__c msps = new PREP_Mat_Serv_Group_Planned_Schedule__c();
        msps.Acquisition_Cycle_Type__c='Standard 12';
        msps.Acquisition_Cycle__c=MatAcqCycle.Id;
        msps.Mat_Serv_Group_Baseline_Allocation_Id__c=MSA.Id;
        msps.R_A_S_Date__c=Date.newInstance(2018, 4, 9);
        msps.Phase_4_Completion_Date__c= Date.newInstance(2018, 5, 10);
        msps.Critical_Vendor_Data_Receipt_1_Weeks__c=2;
        msps.Critical_Vendor_Data_Receipt_2_Weeks__c=2;
        msps.MFG_Lead_Time_Weeks__c=3;
        msps.RecordTypeId='01216000001QPTy';
        insert msps;
        
        Id matId = Schema.SObjectType.PREP_Mat_Serv_Group_Update__c.getRecordTypeInfosByName().get('Mat Group Update').getRecordTypeId();
        Id servId = Schema.SObjectType.PREP_Mat_Serv_Group_Update__c.getRecordTypeInfosByName().get('Serv Group Update').getRecordTypeId();      
        
        PREP_Mat_Serv_Group_Update__c msgu =   new PREP_Mat_Serv_Group_Update__c();
        msgu.Mat_Serv_Group_Planned_Schedule_Id__c =msps.Id;
        msgu.R_A_S_Date__c =Date.newInstance(2017, 7, 7)  ;
        msgu.Planned_Bid_Request_Issued_RFQ__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_MRQ_Received__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Bids_Received__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Commercial_Evaluations_Received__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Technical_Evaluations_Received__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Bid_Tab_Finalized__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Decision_Sum_Issued_Approval__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Decision_Summary_Approved__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_MRP_Received__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_P_O_Issued__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Vendor_Init_Drawing_Submittal__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Drawings_Approved__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Ship_Date__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_ETA__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_Business_Requirements__c =2;
        msgu.Planned_1_Segmentation_Team_Selection__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_1_Segmentation_Team_Selection__c= Date.newInstance(2017, 7, 7);
        msgu.Planned_2_Business_Requirements__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_3_Supplier_Market_Analysis__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_4_Sourcing_Options__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Strategy_Approval__c = Date.newInstance(2017, 7, 7);
        msgu.Planned_Strategy_Approval__c =Date.newInstance(2017, 7, 7);
        msgu.Forecast_Supplier_Market_Analysis__c=1;
        msgu.Forecast_Sourcing_Options__c=3;
        msgu.Forecast_Strategy_Approval_Cycle__c=3;
        msgu.Forecast_Strategy_Approval__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_MRQ_To_Be_Received__c=3;
        msgu.Forecast_Bid_Period__c=3;
        msgu.Forecast_RFQ_Prep__c=2;
        msgu.Actual_MRQ_Received__c =Date.newInstance(2017, 7, 7);
        msgu.Actual_Bid_Request_Issued_RFQ__c =Date.newInstance(2017, 7, 7);
        msgu.Forecast_Bid_Evaluation_1__c=1;
        msgu.Forecast_Bid_Evaluation_2__c=3;
        //msgu.Actual_Bids_Received__c = Date.newInstance(2017, 7, 7);
        //msgu.Actual_Comm_Eval_Received__c =Date.newInstance(2017, 7, 7);
        //msgu.Actual_Tech_Eval_Received__c =Date.newInstance(2017, 7, 7);
        msgu.Forecast_Comm_Eval_Received_Mat__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_Bid_Evaluation_3__c=3;
        msgu.Actual_Comm_Eval_Received__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_Bid_Evaluation_4__c=2;
        msgu.Forecast_Husky_Approval__c=4;
        msgu.Forecast_MRP_Prep__c=2;
        msgu.Forecast_PO_Prep_Issued__c=3;
        msgu.Forecast_Critical_Vendor_Data_Receipt1_W__c=4;
        msgu.Forecast_Critical_Vendor_Data_Receipt2_W__c=1;
        msgu.Forecast_MFG_Lead_Time_Weeks__c=1;
        msgu.Forecast_Shipping_Duration__c=1;
        //msgu.Actual_1_Segmentation_Team_Selection__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_2_Business_Requirements__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_Business_Requirements__c = 1;
        //msgu.Actual_2_Business_Requirements__c = Date.newInstance(2017, 7, 7);
        //msgu.Actual_3_Supplier_Market_Analysis__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_4_Sourcing_Options__c = Date.newInstance(2017, 7, 7);
        //msgu.Actual_Strategy_Approval__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_Bids_Received_Mat__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_CWP_To_Be_Received__c = 1;
        msgu.RecordTypeId = servId;
        msgu.Forecast_CWP_Prep__c = 1;
        msgu.Forecast_CT_Prep_Issued__c = 1;
        msgu.Forecast_Kickoff_Mobilization__c = 1;
        msgu.Forecast_Duration_Of_Work_Weeks__c = 1;
        msgu.Forecast_Demob_Cycle__c = 1;
        msgu.CWP_Completion__c = Date.newInstance(2017, 7, 7);
        msgu.Forecast_Demob__c = Date.newInstance(2017, 7, 7);
        insert msgu;
        
        test.startTest();
            update msgu;
        test.stopTest();
    }
    
    static testmethod void defaultUpdate3(){
        User u = [ Select Id, Name from User where Id =: UserInfo.getUserId() limit 1 ];
        
        PREP_Discipline__c disp = new PREP_Discipline__c( Name = 'Engineering & Construction', Active__c = true, SCM_Manager__c = u.Id );
        insert disp;
        
        PREP_Category__c cat = new PREP_Category__c( Name = 'Category', Active__c = true, Discipline__c = disp.Id );
        insert cat;
        
        PREP_Sub_Category__c sub = new PREP_Sub_Category__c( Name = 'SubCat', Category__c = cat.Id, Category_Manager__c = u.Id,
                                                                Category_Specialist__c = u.Id, Active__c = true );
        insert sub;
        
        PREP_Initiative__c ini = new PREP_Initiative__c( Initiative_Name__c = 'Test ini', Discipline__c = disp.Id, Category__c = cat.Id,
                                Sub_Category__c = sub.Id, Status__c = 'Active', Sourcing_Program__c='delivary Plan', Type__c = 'Category',
                                Risk_Level__c = 'High', HSSM_Package__c = 'Full', Workbook__c = 'Yes', SRPM_Package__c = 'As Needed',
                                Aboriginal__c = 'No', Global_Sourcing__c = 'Yes', OEM__c = 'Yes', Ariba__c='Yes', Ariba_Exception_Reason__c='Singlr Source',
                                Rate_Validation__c = 'Yes', Estimated_Number_of_Master_Data_Required__c=100, Reverse_Auction__c = 'No',
                                Rebate__c = 'Multiple Area Award', Rebate_Frequency__c = 'Annually',PDE_Phase__c='1',Phase_4_Start_Date__c=Date.newInstance(2017, 7, 7),Phase_4_Completion_Date__c=Date.newInstance(2018, 7, 7),
                                Volume_Discount_Frequency__c='Annually', Payment_Terms__c='Net 30', SCM_Manager__c = u.Id, SCM_Team__c='E&C - Equipment',
                                Category_Manager__c = u.Id, Category_Specialist__c = u.Id, RecordTypeId ='01216000001QPTv' );
        insert ini;
        
        PREP_Baseline__c baseline = new PREP_Baseline__c();
        baseline.Baseline_Spend_Dollar_Target__c = 10000;
        baseline.Local_Baseline_Spend_Percent__c = 0.10;
        baseline.Local_Baseline_Savings_Percent__c = 0.10;
        baseline.Global_Baseline_Savings_Percent__c = 0.10;
        baseline.XCAC2_CAC_Award_Approval__c = Date.newInstance(2015, 5, 10);
        baseline.RecordTypeId = '01216000001QPTt';
        baseline.Initiative_Id__c = ini.Id;
        insert baseline;
        
        PREP_Material_Service_Group__c MS = new PREP_Material_Service_Group__c();
        MS.Name = 'MS Name';
        MS.Material_Service_Group_Name__c = 'MS';
        MS.Category_Link__c= cat.Id;
        MS.Sub_Category__c = sub.Id;
        MS.Category_Manager__c = u.Id;
        MS.SAP_Short_Text_Name__c = 'MS';
        MS.Active__c = true;
        MS.Type__c = 'Material';
        MS.Category_Specialist__c = u.Id;
        MS.Includes__c = 'MS';
        MS.Does_Not_Include__c = 'MS';
        //MS.PREP_ForecastDates=Date.newInstance(2015, 5, 10);
        insert MS;
        
        PREP_Mat_Serv_Group_Baseline_Allocation__c MSA = new PREP_Mat_Serv_Group_Baseline_Allocation__c();
        MSA.Baseline_Id__c = baseline.Id;
        MSA.Material_Service_Group__c = MS.Id;
        //MSA.Phase_4_Completion_Date__c=Date.newInstance(2015, 5, 10);
        MSA.RecordTypeId = '01216000001QPTw';
        MSA.Sub_Category__c = sub.Id;
        insert MSA;
        
        PREP_Acquisition_Cycle__c MatAcqCycle = new PREP_Acquisition_Cycle__c();
       // MatAcqCycle.Initiative__c= ini.Id;
        MatAcqCycle.Mat_Serv_Group_Baseline_Allocation__c = MSA.Id;
        MatAcqCycle.RFQ_Prep__c = 3;
        MatAcqCycle.Bid_Period__c =  28;
        MatAcqCycle.Bid_Evaluation_1__c = 21;
        MatAcqCycle.Bid_Evaluation_2__c = 21;
        MatAcqCycle.Bid_Evaluation_3__c = 2;
        MatAcqCycle.Bid_Evaluation_4__c = 7;
        MatAcqCycle.Husky_Approval__c = 7;
        MatAcqCycle.MRP_Prep__c = 7;
        MatAcqCycle.PO_Prep_Issue__c = 9; 
        MatAcqCycle.Shipping_Duration__c = 7;
        MatAcqCycle.Type__c = 'Standard 12';
        MatAcqCycle.RecordTypeId = '01216000001QPTr';
        insert MatAcqCycle;
        
        PREP_Mat_Serv_Group_Planned_Schedule__c msps = new PREP_Mat_Serv_Group_Planned_Schedule__c();
        msps.Acquisition_Cycle_Type__c='Standard 12';
        msps.Acquisition_Cycle__c=MatAcqCycle.Id;
        msps.Mat_Serv_Group_Baseline_Allocation_Id__c=MSA.Id;
        msps.R_A_S_Date__c=Date.newInstance(2018, 4, 9);
        msps.Phase_4_Completion_Date__c= Date.newInstance(2018, 5, 10);
        msps.Critical_Vendor_Data_Receipt_1_Weeks__c=2;
        msps.Critical_Vendor_Data_Receipt_2_Weeks__c=2;
        msps.MFG_Lead_Time_Weeks__c=3;
        msps.RecordTypeId='01216000001QPTy';
        insert msps;
        
        Id matId = Schema.SObjectType.PREP_Mat_Serv_Group_Update__c.getRecordTypeInfosByName().get('Mat Group Update').getRecordTypeId();
        Id servId = Schema.SObjectType.PREP_Mat_Serv_Group_Update__c.getRecordTypeInfosByName().get('Serv Group Update').getRecordTypeId();      
        
        PREP_Mat_Serv_Group_Update__c msgu =   new PREP_Mat_Serv_Group_Update__c();
        msgu.Mat_Serv_Group_Planned_Schedule_Id__c =msps.Id;
        msgu.R_A_S_Date__c =Date.newInstance(2018, 7, 7)  ;
        msgu.Planned_Bid_Request_Issued_RFQ__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_MRQ_Received__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Bids_Received__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Commercial_Evaluations_Received__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Technical_Evaluations_Received__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Bid_Tab_Finalized__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Decision_Sum_Issued_Approval__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Decision_Summary_Approved__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_MRP_Received__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_P_O_Issued__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Vendor_Init_Drawing_Submittal__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Drawings_Approved__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Ship_Date__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_ETA__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_Business_Requirements__c =2;
        msgu.Planned_1_Segmentation_Team_Selection__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_1_Segmentation_Team_Selection__c= Date.newInstance(2018, 7, 7);
        msgu.Planned_2_Business_Requirements__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_3_Supplier_Market_Analysis__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_4_Sourcing_Options__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Strategy_Approval__c = Date.newInstance(2018, 7, 7);
        msgu.Planned_Strategy_Approval__c =Date.newInstance(2018, 7, 7);
        msgu.Forecast_Supplier_Market_Analysis__c=1;
        msgu.Forecast_Sourcing_Options__c=3;
        msgu.Forecast_Strategy_Approval_Cycle__c=3;
        msgu.Forecast_Strategy_Approval__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_MRQ_To_Be_Received__c=3;
        msgu.Forecast_Bid_Period__c=3;
        msgu.Forecast_RFQ_Prep__c=2;
        msgu.Actual_MRQ_Received__c =Date.newInstance(2018, 7, 7);
        msgu.Actual_Bid_Request_Issued_RFQ__c =Date.newInstance(2018, 7, 7);
        msgu.Forecast_Bid_Evaluation_1__c=1;
        msgu.Forecast_Bid_Evaluation_2__c=3;
        msgu.Actual_Bids_Received__c = Date.newInstance(2018, 7, 7);
        msgu.Actual_Comm_Eval_Received__c =Date.newInstance(2018, 7, 7);
        msgu.Actual_Tech_Eval_Received__c =Date.newInstance(2018, 7, 7);
        msgu.Forecast_Comm_Eval_Received_Mat__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_Bid_Evaluation_3__c=3;
        msgu.Actual_Comm_Eval_Received__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_Bid_Evaluation_4__c=2;
        msgu.Forecast_Husky_Approval__c=4;
        msgu.Forecast_MRP_Prep__c=2;
        msgu.Forecast_PO_Prep_Issued__c=3;
        msgu.Forecast_Critical_Vendor_Data_Receipt1_W__c=4;
        msgu.Forecast_Critical_Vendor_Data_Receipt2_W__c=1;
        msgu.Forecast_MFG_Lead_Time_Weeks__c=1;
        msgu.Forecast_Shipping_Duration__c=1;
        msgu.Actual_1_Segmentation_Team_Selection__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_2_Business_Requirements__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_Business_Requirements__c = 1;
        msgu.Actual_2_Business_Requirements__c = Date.newInstance(2018, 7, 7);
        msgu.Actual_3_Supplier_Market_Analysis__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_4_Sourcing_Options__c = Date.newInstance(2018, 7, 7);
        msgu.Actual_Strategy_Approval__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_Bids_Received_Mat__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_CWP_To_Be_Received__c = 1;
        msgu.Forecast_CWP_Prep__c = 1;
        msgu.Forecast_CT_Prep_Issued__c = 1;
        msgu.Forecast_Kickoff_Mobilization__c = 1;
        msgu.Forecast_Duration_Of_Work_Weeks__c = 1;
        msgu.Forecast_Demob_Cycle__c = 1;
        msgu.CWP_Completion__c = Date.newInstance(2018, 7, 7);
        msgu.Forecast_Demob__c = Date.newInstance(2018, 7, 7);
        msgu.RecordTypeId = servId;
        insert msgu;
        
        test.startTest();
            update msgu;
        test.stopTest();
    }
    
    static testmethod void defaultUpdate4(){
        User u = [ Select Id, Name from User where Id =: UserInfo.getUserId() limit 1 ];
        
        PREP_Discipline__c disp = new PREP_Discipline__c( Name = 'Engineering & Construction', Active__c = true, SCM_Manager__c = u.Id );
        insert disp;
        
        PREP_Category__c cat = new PREP_Category__c( Name = 'Category', Active__c = true, Discipline__c = disp.Id );
        insert cat;
        
        PREP_Sub_Category__c sub = new PREP_Sub_Category__c( Name = 'SubCat', Category__c = cat.Id, Category_Manager__c = u.Id,
                                                                Category_Specialist__c = u.Id, Active__c = true );
        insert sub;
        
        PREP_Initiative__c ini = new PREP_Initiative__c( Initiative_Name__c = 'Test ini', Discipline__c = disp.Id, Category__c = cat.Id,
                                Sub_Category__c = sub.Id, Status__c = 'Active', Sourcing_Program__c='delivary Plan', Type__c = 'Category',
                                Risk_Level__c = 'High', HSSM_Package__c = 'Full', Workbook__c = 'Yes', SRPM_Package__c = 'As Needed',
                                Aboriginal__c = 'No', Global_Sourcing__c = 'Yes', OEM__c = 'Yes', Ariba__c='Yes', Ariba_Exception_Reason__c='Singlr Source',
                                Rate_Validation__c = 'Yes', Estimated_Number_of_Master_Data_Required__c=100, Reverse_Auction__c = 'No',
                                Rebate__c = 'Multiple Area Award', Rebate_Frequency__c = 'Annually',PDE_Phase__c='1',Phase_4_Start_Date__c=Date.newInstance(2017, 7, 7),Phase_4_Completion_Date__c=Date.newInstance(2018, 7, 7),
                                Volume_Discount_Frequency__c='Annually', Payment_Terms__c='Net 30', SCM_Manager__c = u.Id, SCM_Team__c='E&C - Equipment',
                                Category_Manager__c = u.Id, Category_Specialist__c = u.Id, RecordTypeId ='01216000001QPTv' );
        insert ini;
        
        PREP_Baseline__c baseline = new PREP_Baseline__c();
        baseline.Baseline_Spend_Dollar_Target__c = 10000;
        baseline.Local_Baseline_Spend_Percent__c = 0.10;
        baseline.Local_Baseline_Savings_Percent__c = 0.10;
        baseline.Global_Baseline_Savings_Percent__c = 0.10;
        baseline.XCAC2_CAC_Award_Approval__c = Date.newInstance(2015, 5, 10);
        baseline.RecordTypeId = '01216000001QPTt';
        baseline.Initiative_Id__c = ini.Id;
        insert baseline;
        
        PREP_Material_Service_Group__c MS = new PREP_Material_Service_Group__c();
        MS.Name = 'MS Name';
        MS.Material_Service_Group_Name__c = 'MS';
        MS.Category_Link__c= cat.Id;
        MS.Sub_Category__c = sub.Id;
        MS.Category_Manager__c = u.Id;
        MS.SAP_Short_Text_Name__c = 'MS';
        MS.Active__c = true;
        MS.Type__c = 'Material';
        MS.Category_Specialist__c = u.Id;
        MS.Includes__c = 'MS';
        MS.Does_Not_Include__c = 'MS';
        //MS.PREP_ForecastDates=Date.newInstance(2015, 5, 10);
        insert MS;
        
        PREP_Mat_Serv_Group_Baseline_Allocation__c MSA = new PREP_Mat_Serv_Group_Baseline_Allocation__c();
        MSA.Baseline_Id__c = baseline.Id;
        MSA.Material_Service_Group__c = MS.Id;
        //MSA.Phase_4_Completion_Date__c=Date.newInstance(2015, 5, 10);
        MSA.RecordTypeId = '01216000001QPTw';
        MSA.Sub_Category__c = sub.Id;
        insert MSA;
        
        PREP_Acquisition_Cycle__c MatAcqCycle = new PREP_Acquisition_Cycle__c();
       // MatAcqCycle.Initiative__c= ini.Id;
        MatAcqCycle.Mat_Serv_Group_Baseline_Allocation__c = MSA.Id;
        MatAcqCycle.RFQ_Prep__c = 3;
        MatAcqCycle.Bid_Period__c =  28;
        MatAcqCycle.Bid_Evaluation_1__c = 21;
        MatAcqCycle.Bid_Evaluation_2__c = 21;
        MatAcqCycle.Bid_Evaluation_3__c = 2;
        MatAcqCycle.Bid_Evaluation_4__c = 7;
        MatAcqCycle.Husky_Approval__c = 7;
        MatAcqCycle.MRP_Prep__c = 7;
        MatAcqCycle.PO_Prep_Issue__c = 9; 
        MatAcqCycle.Shipping_Duration__c = 7;
        MatAcqCycle.Type__c = 'Standard 12';
        MatAcqCycle.RecordTypeId = '01216000001QPTr';
        insert MatAcqCycle;
        
        PREP_Mat_Serv_Group_Planned_Schedule__c msps = new PREP_Mat_Serv_Group_Planned_Schedule__c();
        msps.Acquisition_Cycle_Type__c='Standard 12';
        msps.Acquisition_Cycle__c=MatAcqCycle.Id;
        msps.Mat_Serv_Group_Baseline_Allocation_Id__c=MSA.Id;
        msps.R_A_S_Date__c=Date.newInstance(2018, 4, 9);
        msps.Phase_4_Completion_Date__c= Date.newInstance(2018, 5, 10);
        msps.Critical_Vendor_Data_Receipt_1_Weeks__c=2;
        msps.Critical_Vendor_Data_Receipt_2_Weeks__c=2;
        msps.MFG_Lead_Time_Weeks__c=3;
        msps.RecordTypeId='01216000001QPTy';
        insert msps;
        
        Id matId = Schema.SObjectType.PREP_Mat_Serv_Group_Update__c.getRecordTypeInfosByName().get('Mat Group Update').getRecordTypeId();
        Id servId = Schema.SObjectType.PREP_Mat_Serv_Group_Update__c.getRecordTypeInfosByName().get('Serv Group Update').getRecordTypeId();      
        
        PREP_Mat_Serv_Group_Update__c msgu1 =   new PREP_Mat_Serv_Group_Update__c();
        msgu1.Mat_Serv_Group_Planned_Schedule_Id__c =msps.Id;
        //msgu1.R_A_S_Date__c = Date.newInstance(2018, 1,12);           
        msgu1.RecordTypeId = servId;
        msgu1.Planned_CWP_Received__c = Date.newInstance(2018, 1,12);
        msgu1.Planned_RFQ_Issued__c =Date.newInstance(2018, 1,12);
        msgu1.Planned_Bids_Received__c =Date.newInstance(2018, 1,12);
        msgu1.Planned_Commercial_Evaluations_Received__c = Date.newInstance(2018, 1,12);
        msgu1.Planned_Technical_Evaluations_Received__c = Date.newInstance(2018, 1,12);
        msgu1.Planned_Bid_Tab_Finalized__c = Date.newInstance(2018, 1,12);
        msgu1.Planned_Decision_Sum_Issued_Approval__c = Date.newInstance(2018, 1,12);
        msgu1.Planned_Decision_Summary_Approved__c = Date.newInstance(2018, 1,12);
        msgu1.Planned_Final_CWP_Received__c = Date.newInstance(2018, 1,12);
        msgu1.Planned_Contract_Executed_LOA_Effective__c = Date.newInstance(2018, 1,12);
        msgu1.Planned_Mobilization_Construction_Start__c = Date.newInstance(2018, 1,12);
        msgu1.Planned_Construction_Completion__c = Date.newInstance(2018, 1,12);
        msgu1.Planned_Demob__c = Date.newInstance(2018, 1,12);
        msgu1.CWP_Completion__c = Date.newInstance(2018, 1,12);
        msgu1.Planned_1_Segmentation_Team_Selection__c = Date.newInstance(2018, 1,12);
        msgu1.Forecast_1_Segmentation_Team_Selection__c = Date.newInstance(2018, 1,12);
        msgu1.Planned_2_Business_Requirements__c = Date.newInstance(2018, 1,12);
        msgu1.Planned_3_Supplier_Market_Analysis__c = Date.newInstance(2018, 1,12);
        msgu1.Planned_4_Sourcing_Options__c = Date.newInstance(2018, 1,12);
        msgu1.Planned_Strategy_Approval__c = Date.newInstance(2018, 1,12);
        //msgu1.Actual_1_Segmentation_Team_Selection__c = Date.newInstance(2018, 1,12);
        msgu1.Forecast_Business_Requirements__c = 1;  
        msgu1.Forecast_Supplier_Market_Analysis__c=1;  
        //msgu1.Actual_3_Supplier_Market_Analysis__c = Date.newInstance(2017, 29,11);
        //msgu1.Actual_2_Business_Requirements__c=Date.newInstance(2017, 30,11);
        msgu1.Actual_3_Supplier_Market_Analysis__c=Date.newInstance(2018, 1,12);
        msgu1.Forecast_Sourcing_Options__c=1;
        msgu1.Forecast_Strategy_Approval_Cycle__c = 1;
        msgu1.Forecast_MRQ_To_Be_Received__c = 1;
        msgu1.Forecast_RFQ_Prep__c = 1;
        msgu1.Forecast_Bid_Period__c = 1;
        msgu1.Forecast_Bid_Evaluation_1__c = 1;
        msgu1.Forecast_Bid_Evaluation_2__c = 1;
        msgu1.Forecast_Bid_Evaluation_3__c = 1;
        msgu1.Forecast_Bid_Evaluation_4__c = 1;
        msgu1.Forecast_Husky_Approval__c = 1;
        msgu1.Forecast_MRP_Prep__c = 1;
        msgu1.Forecast_PO_Prep_Issued__c = 1;
        msgu1.Forecast_Critical_Vendor_Data_Receipt1_W__c = 1;
        msgu1.Forecast_Critical_Vendor_Data_Receipt2_W__c = 1;
        msgu1.Forecast_MFG_Lead_Time_Weeks__c = 1;
        msgu1.Forecast_Shipping_Duration__c = 1;
        msgu1.Forecast_ETA__c = Date.newInstance(2018, 1,12);
        msgu1.R_A_S_Date__c = Date.newInstance(2018, 1,12);
        msgu1.RecordTypeId = matId;
        insert msgu1;
        
        test.startTest();
            update msgu1;
        test.stopTest();
    }
    
    static testmethod void defaultUpdate5(){
        User u = [ Select Id, Name from User where Id =: UserInfo.getUserId() limit 1 ];
        
        PREP_Discipline__c disp = new PREP_Discipline__c( Name = 'Engineering & Construction', Active__c = true, SCM_Manager__c = u.Id );
        insert disp;
        
        PREP_Category__c cat = new PREP_Category__c( Name = 'Category', Active__c = true, Discipline__c = disp.Id );
        insert cat;
        
        PREP_Sub_Category__c sub = new PREP_Sub_Category__c( Name = 'SubCat', Category__c = cat.Id, Category_Manager__c = u.Id,
                                                                Category_Specialist__c = u.Id, Active__c = true );
        insert sub;
        
        PREP_Initiative__c ini = new PREP_Initiative__c( Initiative_Name__c = 'Test ini', Discipline__c = disp.Id, Category__c = cat.Id,
                                Sub_Category__c = sub.Id, Status__c = 'Active', Sourcing_Program__c='delivary Plan', Type__c = 'Category',
                                Risk_Level__c = 'High', HSSM_Package__c = 'Full', Workbook__c = 'Yes', SRPM_Package__c = 'As Needed',
                                Aboriginal__c = 'No', Global_Sourcing__c = 'Yes', OEM__c = 'Yes', Ariba__c='Yes', Ariba_Exception_Reason__c='Singlr Source',
                                Rate_Validation__c = 'Yes', Estimated_Number_of_Master_Data_Required__c=100, Reverse_Auction__c = 'No',
                                Rebate__c = 'Multiple Area Award', Rebate_Frequency__c = 'Annually',PDE_Phase__c='1',Phase_4_Start_Date__c=Date.newInstance(2017, 7, 7),Phase_4_Completion_Date__c=Date.newInstance(2018, 7, 7),
                                Volume_Discount_Frequency__c='Annually', Payment_Terms__c='Net 30', SCM_Manager__c = u.Id, SCM_Team__c='E&C - Equipment',
                                Category_Manager__c = u.Id, Category_Specialist__c = u.Id, RecordTypeId ='01216000001QPTv' );
        insert ini;
        
        PREP_Baseline__c baseline = new PREP_Baseline__c();
        baseline.Baseline_Spend_Dollar_Target__c = 10000;
        baseline.Local_Baseline_Spend_Percent__c = 0.10;
        baseline.Local_Baseline_Savings_Percent__c = 0.10;
        baseline.Global_Baseline_Savings_Percent__c = 0.10;
        baseline.XCAC2_CAC_Award_Approval__c = Date.newInstance(2015, 5, 10);
        baseline.RecordTypeId = '01216000001QPTt';
        baseline.Initiative_Id__c = ini.Id;
        insert baseline;
        
        PREP_Material_Service_Group__c MS = new PREP_Material_Service_Group__c();
        MS.Name = 'MS Name';
        MS.Material_Service_Group_Name__c = 'MS';
        MS.Category_Link__c= cat.Id;
        MS.Sub_Category__c = sub.Id;
        MS.Category_Manager__c = u.Id;
        MS.SAP_Short_Text_Name__c = 'MS';
        MS.Active__c = true;
        MS.Type__c = 'Material';
        MS.Category_Specialist__c = u.Id;
        MS.Includes__c = 'MS';
        MS.Does_Not_Include__c = 'MS';
        //MS.PREP_ForecastDates=Date.newInstance(2015, 5, 10);
        insert MS;
        
        PREP_Mat_Serv_Group_Baseline_Allocation__c MSA = new PREP_Mat_Serv_Group_Baseline_Allocation__c();
        MSA.Baseline_Id__c = baseline.Id;
        MSA.Material_Service_Group__c = MS.Id;
        //MSA.Phase_4_Completion_Date__c=Date.newInstance(2015, 5, 10);
        MSA.RecordTypeId = '01216000001QPTw';
        MSA.Sub_Category__c = sub.Id;
        insert MSA;
        
        PREP_Acquisition_Cycle__c MatAcqCycle = new PREP_Acquisition_Cycle__c();
       // MatAcqCycle.Initiative__c= ini.Id;
        MatAcqCycle.Mat_Serv_Group_Baseline_Allocation__c = MSA.Id;
        MatAcqCycle.RFQ_Prep__c = 3;
        MatAcqCycle.Bid_Period__c =  28;
        MatAcqCycle.Bid_Evaluation_1__c = 21;
        MatAcqCycle.Bid_Evaluation_2__c = 21;
        MatAcqCycle.Bid_Evaluation_3__c = 2;
        MatAcqCycle.Bid_Evaluation_4__c = 7;
        MatAcqCycle.Husky_Approval__c = 7;
        MatAcqCycle.MRP_Prep__c = 7;
        MatAcqCycle.PO_Prep_Issue__c = 9; 
        MatAcqCycle.Shipping_Duration__c = 7;
        MatAcqCycle.Type__c = 'Standard 12';
        MatAcqCycle.RecordTypeId = '01216000001QPTr';
        insert MatAcqCycle;
        
        PREP_Mat_Serv_Group_Planned_Schedule__c msps = new PREP_Mat_Serv_Group_Planned_Schedule__c();
        msps.Acquisition_Cycle_Type__c='Standard 12';
        msps.Acquisition_Cycle__c=MatAcqCycle.Id;
        msps.Mat_Serv_Group_Baseline_Allocation_Id__c=MSA.Id;
        msps.R_A_S_Date__c=Date.newInstance(2018, 4, 9);
        msps.Phase_4_Completion_Date__c= Date.newInstance(2018, 5, 10);
        msps.Critical_Vendor_Data_Receipt_1_Weeks__c=2;
        msps.Critical_Vendor_Data_Receipt_2_Weeks__c=2;
        msps.MFG_Lead_Time_Weeks__c=3;
        msps.RecordTypeId='01216000001QPTy';
        insert msps;
        
        Id matId = Schema.SObjectType.PREP_Mat_Serv_Group_Update__c.getRecordTypeInfosByName().get('Mat Group Update').getRecordTypeId();
        Id servId = Schema.SObjectType.PREP_Mat_Serv_Group_Update__c.getRecordTypeInfosByName().get('Serv Group Update').getRecordTypeId();      
        
        PREP_Mat_Serv_Group_Update__c msgu1 =   new PREP_Mat_Serv_Group_Update__c();
            msgu1.Mat_Serv_Group_Planned_Schedule_Id__c =msps.Id;
            //msgu1.R_A_S_Date__c = Date.newInstance(2017, 1,12);          
            msgu1.RecordTypeId = servId;
                                                msgu1.Planned_1_Segmentation_Team_Selection__c= Date.newInstance(2017, 1,11);
                                                msgu1.Actual_1_Segmentation_Team_Selection__c=Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_Business_Requirements__c =2;
                                                msgu1.Actual_2_Business_Requirements__c= Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_Supplier_Market_Analysis__c=1;
                                                msgu1.Actual_3_Supplier_Market_Analysis__c=Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_Sourcing_Options__c=2;
                                                msgu1.Actual_4_Sourcing_Options__c=Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_Strategy_Approval_Cycle__c=2;
                                                msgu1.Actual_Strategy_Approval__c=Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_CWP_To_Be_Received__c=2;
                                                msgu1.Actual_CWP_Received__c=Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_RFQ_Prep__c=2;
                                                msgu1.Actual_RFQ_Issued__c=Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_Bid_Period__c=2;
                                                msgu1.Actual_Bids_Received__c=Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_Bid_Evaluation_1__c=1;
                                                msgu1.Actual_Bids_Received__c =Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_Bid_Evaluation_2__c=3;
                                                msgu1.Actual_Comm_Eval_Received__c=Date.newInstance(2017, 3,11);
                                                msgu1.Actual_Tech_Eval_Received__c =Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_Bid_Evaluation_3__c=1;
                                                msgu1.Actual_Bid_Tab_Finalized__c=Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_Bid_Evaluation_4__c=3;
                                                msgu1.Actual_Decision_Sum_Issued_Approval__c=Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_Husky_Approval__c=4;
                                                //msgu1.Actual_Decision_Summary_Approved__c=Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_CWP_Prep__c=4;
                                                msgu1.Actual_Final_CWP_Received__c=Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_CT_Prep_Issued__c=2;
                                                msgu1.Actual_Contract_Executed_LOA_Effective__c=Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_Kickoff_Mobilization__c=1;
                                                msgu1.Actual_Mobilization_Construction_Start__c=Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_Duration_Of_Work_Weeks__c=2;
                                                msgu1.Actual_Construction_Completion__c=Date.newInstance(2017, 1,11);
                                                msgu1.Forecast_Demob_Cycle__c=3;
                                                msgu1.Actual_Demob__c=Date.newInstance(2017, 1,11);
                                                msgu1.CWP_Completion__c=Date.newInstance(2017, 20,11);
                                                msgu1.Planned_Contract_Execution__c = Date.newInstance(2017, 20,11);
                                                insert msgu1;
        //insert msgu1;
        
        test.startTest();
            update msgu1;
        test.stopTest();
    }
}